/***********************************************
*  FreeRTOS Test Program sample7
*  GateKeeper Task Control
***********************************************/
#include <p32xxxx.h>
#include "FreeRTOS.h" 					/* FreeRTOSwb_ */
#include "queue.h"
#include "semphr.h"

/***  RtBM[Vݒ  ***/
//CPU=80MHz Peri=80MHz, HS+PLL, Divider=1/2, PLL=20x, WDT=Off
#pragma config FNOSC = PRIPLL, POSCMOD = HS, FPLLIDIV = DIV_2
#pragma config FPLLMUL = MUL_20, FPBDIV = DIV_1, FPLLODIV = DIV_1
#pragma config FWDTEN = OFF, OSCIOFNC = ON, ICESEL = ICS_PGx2
/* 萔` */
#define SYS_FREQ	80000000				// Fcy
#define BAUD 		9600					// UART Baud Rate
/* ϐ`*/
xQueueHandle UARTQueue;
/* ֐vg */
void vTask1( void *pvParameters );			// ^XN1
void vTask2( void *pvParameters );			// ^XN2
void vTask3( void *pvParameters );			// ^XN3
void itostring(char digit, unsigned int data, char *buffer);

/****************** C֐ ************************/
int main(void){
	/* VXeݒ */
	SYSTEMConfigPerformance(SYS_FREQ);		// VXeő
	mJTAGPortEnable(DEBUG_JTAGPORT_OFF);	// JTAG𖳌
	LATA = 0; 							// LEDݒ
	TRISA = 0;

	/* Open UART2 with Receive and Transmitter enable  */
	OpenUART2(UART_EN, UART_RX_ENABLE | UART_TX_ENABLE, SYS_FREQ/16/BAUD-1);
	printf("\r\n*** FreeRTOS Test Program No7 ***\r\n");
	/* 荞݋ */
	INTEnableSystemMultiVectoredInt();
	/* L[obt@@*/
	UARTQueue = xQueueCreate(5, 22);		// 22Byte x 5
	if(UARTQueue != NULL){
		/* ^XN  */
		xTaskCreate( vTask1, "Task1", 200, NULL, 1, NULL );
		xTaskCreate( vTask2, "Task2", 200, NULL, 1, NULL );
		xTaskCreate( vTask3, "Task3", 200, NULL, 1, NULL );
		/* XPW[OJn@*/
		vTaskStartScheduler();
	}
	/********@C[v  *******/
	while(1)
	{	}
}

/***** ^XN1֐ ******/
void vTask1(void *pvParameters){
	static unsigned char Msg1[] = "Task1 Count = xxxxx\r\n";
	static unsigned int Count1 = 0;

	while(1)	{	// 0.4bŌJԂ
		LATA ^= 0x80;							// LED_
		itostring(5, Count1, Msg1+14);			// bZ[Wp
		xQueueSendToBack(UARTQueue, Msg1, portMAX_DELAY);
		Count1++;
		vTaskDelay( 400 / portTICK_RATE_MS );
	}
}
/***** ^XN2֐ ******/
void vTask2(void *pvParameters){
	static unsigned char Msg2[] = "Task2 Count = xxxxx\r\n";
	static unsigned int Count2 = 0;

	while(1)	{	// 0.2bŌJԂ
		LATA ^= 0x40;							// LED_
		itostring(5, Count2, Msg2+14);			// bZ[Wp
		xQueueSendToBack(UARTQueue, Msg2, portMAX_DELAY);
		Count2++;
		vTaskDelay( 200 / portTICK_RATE_MS );
	}
}
/***** ^XN3֐ ******/
void vTask3(void *pvParameters){
	unsigned char Buf[32];

	while(1) {
		LATA ^= 0x20;						// LED_
		/* L[f[^o */
		xQueueReceive(UARTQueue, Buf, portMAX_DELAY);
		printf(Buf);
	}
}
/*****************************************
*   l當ɕϊ
*****************************************/
void itostring(char digit, unsigned int data, char *buffer)
{
	char i;

	buffer += digit;						//̍Ō
	for(i=digit; i>0; i--) {				//ŉʌʂ
		buffer--;						//|C^[P
		*buffer = (data % 10) + '0';		//̌l𕶎ɂĊi[
		data = data / 10;					//-1
	}
}
